Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 15017)
@@ -5,5 +5,5 @@
 
   using HeuristicLab.BenchmarkSuite;
-  using HeuristicLab.Encodings.IntegerVectorEncoding;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
 
   using Instances;
@@ -38,11 +38,11 @@
       PushEvaluator.LoadData(data);
 
-      BestKnownQuality = data.BestResult;
-      MaxPointsInProgram = data.MaxSize;
-      MinPointsInProgram = data.MaxSize;
-      EvalPushLimit = data.EvalLimit;
-      ErcOptions = data.ErcOptions;
       Name = "Push Problem: " + data.Name;
       Description = data.Description;
+      BestKnownQuality = data.BestResult;
+      config.MaxPointsInProgram = data.MaxSize;
+      config.EvalPushLimit = data.EvalLimit;
+      config.ErcOptions = data.ErcOptions;
+      config.FloatStringFormat = data.FloatStringFormat;
 
       config.SetEnabledStacks((StackTypes)data.EnabledDataTypes);
@@ -50,14 +50,15 @@
       Encoding.Bounds[0, 0] = 0;
       Encoding.Bounds[0, 1] = config.EnabledExpressions.Count;
-      Encoding.Length = config.MaxPointsInProgram;
+
+      InitProgramLength = data.MaxSize / 2;
     }
 
     protected override PushSolution CreatePushSolution(
-      IntegerVector vector,
+      PushProgram program,
       double bestQuality,
       IRandom random,
       IReadOnlyPushConfiguration config,
       IPushEvaluator evaluator) {
-      return new PushBenchmarkSuiteSolution(vector, bestQuality, random, (IReadOnlyPushConfiguration)config.Clone(), (PushBenchmarkSuiteEvaluator)PushEvaluator.Clone());
+      return new PushBenchmarkSuiteSolution(program, bestQuality, random, (IReadOnlyPushConfiguration)config.Clone(), (PushBenchmarkSuiteEvaluator)PushEvaluator.Clone());
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteSolution.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteSolution.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteSolution.cs	(revision 15017)
@@ -3,5 +3,7 @@
   using Configuration;
   using Core;
-  using Encodings.IntegerVectorEncoding;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
   using Persistence.Default.CompositeSerializers.Storable;
 
@@ -9,10 +11,10 @@
   public class PushBenchmarkSuiteSolution : PushSolution {
     public PushBenchmarkSuiteSolution(
-      IntegerVector integerVector,
+      PushProgram program,
       double quality,
       IRandom random,
       IReadOnlyPushConfiguration config,
       PushBenchmarkSuiteEvaluator evaluator,
-      bool simplify = false) : base(integerVector, quality, random, config, evaluator, simplify) {
+      bool simplify = false) : base(program, quality, random, config, evaluator, simplify) {
     }
 
@@ -23,5 +25,5 @@
 
     public override PushSolution Simplify() {
-      return new PushBenchmarkSuiteSolution(IntegerVector, Quality, Random, Config, (PushBenchmarkSuiteEvaluator)Evaluator, true);
+      return new PushBenchmarkSuiteSolution(Program, Quality, Random, Config, (PushBenchmarkSuiteEvaluator)Evaluator, true);
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/EvaluationResult.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/EvaluationResult.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/EvaluationResult.cs	(revision 15017)
@@ -6,5 +6,5 @@
 
 
-    public double TotalQuality { get; set; }
+    public double AvgQuality { get; set; }
     public double[] ExampleQualities { get; set; }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IPushEvaluator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IPushEvaluator.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IPushEvaluator.cs	(revision 15017)
@@ -8,8 +8,8 @@
   public interface IPushEvaluator : IDeepCloneable {
     EvaluationResult EvaluateTest(IReadOnlyPushConfiguration config, PushProgram program, IRandom random);
-    EvaluationResult EvaluateTest(IPushInterpreter interpreter, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTest(IPushInterpreter interpreter, PushProgram program);
     EvaluationResult EvaluateTest(PushInterpreterPool pool, PushProgram program, IRandom random);
     EvaluationResult EvaluateTraining(IReadOnlyPushConfiguration config, PushProgram program, IRandom random);
-    EvaluationResult EvaluateTraining(IPushInterpreter interpreter, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTraining(IPushInterpreter interpreter, PushProgram program);
     EvaluationResult EvaluateTraining(PushInterpreterPool pool, PushProgram program, IRandom random);
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs	(revision 15017)
@@ -1,3 +1,4 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
+  using System.Collections.Generic;
 
   using HeuristicLab.Core;
@@ -7,4 +8,5 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
   using HeuristicLab.Random;
@@ -17,4 +19,8 @@
     public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config) {
       return individual.IntegerVector().ToPushProgram(config);
+    }
+
+    public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config, IRandom random) {
+      return individual.IntegerVector().ToPushProgram(config, random);
     }
 
@@ -35,19 +41,63 @@
     }
 
-    private static int GetSeed(this IntegerVector vector) {
-      var seed = 0;
+    public static int GetSeed(this IntegerVector vector) {
+      var seed = 17;
       for (var i = 0; i < vector.Length; i++)
-        seed += (i + 1) * vector[i];
+        seed = seed * 23 + vector[i];
       return seed;
     }
 
-    private static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config, IRandom random) {
-      var enabledExpressions = config.EnabledExpressions;
-      var ercOptions = config.ErcOptions;
-      //var programLength = random.Next(config.MinPointsInProgram, config.MaxPointsInProgram + 1);
-      var expressions = new Expression[vector.Length];
+    public static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config, IRandom random) {
+      var currentIndex = 0;
+      var close = 0;
 
-      for (var i = 0; i < vector.Length; i++)
-        expressions[i] = CodeGeneratorUtils.CreateExpressionOrErc(vector[i], random, enabledExpressions, ercOptions);
+      return FromPlush(vector, ref currentIndex, ref close, 0, config, random);
+    }
+
+    private static PushProgram FromPlush(IntegerVector vector, ref int currentIndex, ref int close, int depth, IReadOnlyPushConfiguration config, IRandom random) {
+      if (currentIndex >= vector.Length)
+        return PushProgram.Empty;
+
+      var expressions = new List<Expression>();
+
+      for (; currentIndex < vector.Length; currentIndex++) {
+        var expression = CodeGeneratorUtils.CreateExpressionOrErc(
+          vector[currentIndex] % config.EnabledExpressions.Count,
+          random,
+          config.EnabledExpressions,
+          config.ErcOptions);
+
+        var expressionType = expression.GetType();
+        close += random.NextBiased(0, config.MaxParenthesesClose, config.ParenthesesCloseBiasLevel);
+
+
+        // check if expression requires additional blocks
+        if (ExpressionTable.TypeToAttributeTable.ContainsKey(expressionType)) {
+          var attr = ExpressionTable.TypeToAttributeTable[expressionType];
+
+          for (var blockIdx = 0u; blockIdx < attr.ExecIn && currentIndex < vector.Length; blockIdx++) {
+            if (close != 0) {
+              close--;
+              expressions.Add(PushProgram.Empty);
+            } else {
+              currentIndex++;
+              var subProgram = FromPlush(vector, ref currentIndex, ref close, depth + 1, config, random);
+              var subExpression = subProgram.Count == 1 ? subProgram.Expressions[0] : subProgram;
+              expressions.Add(subExpression);
+            }
+          }
+        }
+
+        expressions.Add(expression);
+
+        if (close > 0 && depth > 0) {
+          close--;
+          break;
+        }
+
+        if (depth == 0) {
+          close = 0;
+        }
+      }
 
       return new PushProgram(expressions);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 15017)
@@ -10,5 +10,5 @@
   using HeuristicLab.Data;
   using HeuristicLab.Encodings.IntegerVectorEncoding;
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite;
 
@@ -22,17 +22,16 @@
   public abstract class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding> {
     [Storable]
-    protected readonly PushConfiguration config;
+    protected readonly PushConfigurationParameterCollection config;
     protected PushInterpreterPool pool;
-    protected readonly ObjectPool<IRandom> randomPool = new ObjectPool<IRandom>(() => new MersenneTwister());
+    protected readonly ObjectPool<IRandom> randomPool = new ObjectPool<IRandom>(() => new MersenneTwister(), Environment.ProcessorCount * 4);
 
     [Storable]
     protected readonly IPushEvaluator PushEvaluator;
 
-    public const string CaseQualitiesScopeParameterName = "CaseQualities";
     private const string BestTrainingSolutionResultName = "Best Solution";
     private const string TestQualityResultName = "Test Quality";
 
     protected PushProblem(PushBenchmarkSuiteEvaluator evaluator) {
-      config = new PushConfiguration();
+      config = new PushConfigurationParameterCollection();
       PushEvaluator = evaluator;
 
@@ -40,4 +39,5 @@
       InitEvents();
       InitParameters();
+      InitEncoding();
     }
 
@@ -61,4 +61,5 @@
       InitData();
       InitEvents();
+      InitParameters();
     }
 
@@ -76,74 +77,47 @@
     }
 
+    public ILookupParameter<IntValue> SeedParamater
+    {
+      get { return (ILookupParameter<IntValue>)Parameters["Seed"]; }
+    }
+
     #region Parameters
-
-    private const string InstructionsParameterName = "Instructions";
-    private const string InstructionsParameterDescription = "Enables/Disables Instructions";
-    private const string EvalPushLimitParameterName = "EvalPushLimit";
-    private const string EvalPushLimitParameterDescription = "This is the maximum allowed number of \"executions\" in a single top-level call to the interpreter. The execution of a single Push instruction counts as one execution, as does the processing of a single literal, as does the descent into one layer of parentheses (that is, the processing of the \"(\" counts as one execution).";
-    private const string MinPointsInProgramParameterName = "MinProgramLength";
-    private const string MinProgramLengthParameterDescription = "This is the minimum size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
-    private const string MaxPointsInProgramParameterName = "MaxProgramLength";
-    private const string MaxProgramLengthParameterDescription = "This is the maximum size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
-    private const string TopLevelPushCodeParameterName = "TopLevelPushCode";
-    private const string TopLevelPushCodeParameterDescription = "When TRUE (which is the default), code passed to the top level of the interpreter will be pushed onto the CODE stack prior to execution.";
-    private const string TopLevelPopCodeParameterName = "TopLevelPopCode";
-    private const string TopLevelPopCodeParameterDescription = "When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.";
-    private const string MaxPointsInRandomInstructionParameterName = "MaxPointsInRandomInstruction";
-    private const string MaxPointsInRandomInstructionParameterDescription = "MaxPointsInRandomInstruction";
-    private const string ErcOptionsParameterName = "ERC options";
-    private const string MaxStringLengthParameterName = "Max. string length";
-    private const string MaxDepthParameterName = "Max. program recursion";
+    private const string InitProgramLengthParameterName = "InitProgramLength";
+    private const string InitProgramLengthParameterDescription = "This is the initial size of a push program.";
+
+    public const string CasesScopeParameterName = "CaseQualities";
+    public const string CaseQualitiesScopeParameterName = "CaseQualities";
 
     private void InitParameters() {
-      Parameters.Add(new ValueParameter<IEnabledExpressionsConfiguration>(
-        InstructionsParameterName,
-        InstructionsParameterDescription,
-        config));
-
-      Parameters.Add(new ValueParameter<ErcOptions>(ErcOptionsParameterName, config.ErcOptions));
-
-      Parameters.Add(new FixedValueParameter<IntValue>(
-        EvalPushLimitParameterName,
-        EvalPushLimitParameterDescription,
-        new IntValue(config.EvalPushLimit)));
-
-      Parameters.Add(new FixedValueParameter<IntValue>(
-        MinPointsInProgramParameterName,
-        MinProgramLengthParameterDescription,
-        new IntValue(config.MinPointsInProgram)) { Hidden = true });
-
-      Parameters.Add(new FixedValueParameter<IntValue>(
-        MaxPointsInProgramParameterName,
-        MaxProgramLengthParameterDescription,
-        new IntValue(config.MaxPointsInProgram)));
-      Encoding.LengthParameter = MaxPointsInProgramParameter as IFixedValueParameter<IntValue>;
-
-      Parameters.Add(new FixedValueParameter<BoolValue>(
-        TopLevelPushCodeParameterName,
-        TopLevelPushCodeParameterDescription,
-        new BoolValue(config.TopLevelPushCode)) { Hidden = true });
-
-      Parameters.Add(new FixedValueParameter<BoolValue>(
-        TopLevelPopCodeParameterName,
-        TopLevelPopCodeParameterDescription,
-        new BoolValue(config.TopLevelPopCode)) { Hidden = true });
-
-      Parameters.Add(new FixedValueParameter<IntValue>(
-        MaxPointsInRandomInstructionParameterName,
-        MaxPointsInRandomInstructionParameterDescription,
-        new IntValue(config.MaxPointsInRandomExpression)) { Hidden = true });
-
-      Parameters.Add(new FixedValueParameter<IntValue>(
-        MaxStringLengthParameterName,
-        new IntValue(config.MaxStringLength)) { Hidden = true });
-
-      Parameters.Add(new FixedValueParameter<IntValue>(
-        MaxDepthParameterName,
-        new IntValue(config.MaxDepth)) { Hidden = true });
-
-      Parameters.Add(new LookupParameter<BoolArray>("Cases", "The training cases that have been successfully executed."));
-      Parameters.Add(new LookupParameter<DoubleArray>(CaseQualitiesScopeParameterName, "The quality of every single training case for each individual"));
-
+      foreach (var paramater in config.Parameters) {
+        if (!Parameters.ContainsKey(paramater.Name)) {
+          Parameters.Add(paramater);
+        }
+      }
+
+      if (!Parameters.ContainsKey(InitProgramLengthParameterName)) {
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          InitProgramLengthParameterName,
+          InitProgramLengthParameterDescription,
+          new IntValue(50)));
+      }
+
+      Encoding.LengthParameter = InitProgramLengthParameter as IFixedValueParameter<IntValue>;
+
+      if (!Parameters.ContainsKey(CasesScopeParameterName))
+        Parameters.Add(new LookupParameter<BoolArray>(CasesScopeParameterName, "The training cases that have been successfully executed."));
+
+      if (!Parameters.ContainsKey(CaseQualitiesScopeParameterName))
+        Parameters.Add(new LookupParameter<DoubleArray>(CaseQualitiesScopeParameterName, "The quality of every single training case for each individual"));
+    }
+
+    protected override void OnReset() {
+      base.OnReset();
+
+      // clear pools and free reserved memory
+      pool.Clear();
+    }
+
+    private void InitEncoding() {
       Encoding.Bounds[0, 0] = 0;
       Encoding.Bounds[0, 1] = config.EnabledExpressions.Count;
@@ -151,183 +125,18 @@
     }
 
-    public IValueParameter<IEnabledExpressionsConfiguration> InstructionsParameter
+    /// <summary>
+    ///     This is the inital size of an push program generated by a solution creator
+    /// </summary>
+    public IValueParameter<IntValue> InitProgramLengthParameter
     {
-      get { return (IValueParameter<IEnabledExpressionsConfiguration>)Parameters[InstructionsParameterName]; }
-    }
-
-    public IEnabledExpressionsConfiguration Instructions
+      get { return (IValueParameter<IntValue>)Parameters[InitProgramLengthParameterName]; }
+    }
+
+    public int InitProgramLength
     {
-      get { return InstructionsParameter.Value; }
-      set { InstructionsParameter.Value = value; }
-    }
-
-    public IValueParameter<ErcOptions> ErcOptionsParameter
-    {
-      get { return (IValueParameter<ErcOptions>)Parameters[ErcOptionsParameterName]; }
-    }
-
-    public ErcOptions ErcOptions
-    {
-      get { return config.ErcOptions; }
+      get { return InitProgramLengthParameter.Value.Value; }
       set
       {
-        ErcOptionsParameter.Value = value;
-        config.ErcOptions = value;
-      }
-    }
-
-    /// <summary>
-    ///     This is the maximum allowed number of "executions" in a single top-level call to the interpreter.
-    ///     The execution of a single Push instruction counts as one execution, as does the processing of a single literal,
-    ///     as does the descent into one layer of parentheses (that is, the processing of the "(" counts as one execution).
-    ///     When this limit is exceeded the interpreter aborts immediately, leaving its stacks in the states they were in prior
-    ///     to the abort (so they may still be examined by a calling program). Whether or not this counts as an "abnormal"
-    ///     termination
-    ///     is up to the calling program.
-    /// </summary>
-    public IValueParameter<IntValue> EvalPushLimitParameter
-    {
-      get { return (IValueParameter<IntValue>)Parameters[EvalPushLimitParameterName]; }
-    }
-
-    public int EvalPushLimit
-    {
-      get { return config.EvalPushLimit; }
-      set
-      {
-        EvalPushLimitParameter.Value.Value = value;
-        config.EvalPushLimit = value;
-      }
-    }
-
-    /// <summary>
-    /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
-    /// </summary>
-    public IValueParameter<IntValue> MaxDepthParameter
-    {
-      get { return (IValueParameter<IntValue>)Parameters[MaxDepthParameterName]; }
-    }
-
-    public int MaxDepth
-    {
-      get { return config.MaxDepth; }
-      set
-      {
-        MaxDepthParameter.Value.Value = value;
-        config.MaxDepth = value;
-      }
-    }
-
-    /// <summary>
-    ///     This is the maximum size of an item on the CODE stack, expressed as a number of points.
-    ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
-    ///     exceeded
-    ///     should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
-    ///     instruction.
-    /// </summary>
-    public IValueParameter<IntValue> MaxPointsInProgramParameter
-    {
-      get { return (IValueParameter<IntValue>)Parameters[MaxPointsInProgramParameterName]; }
-    }
-
-    public int MaxPointsInProgram
-    {
-      get { return config.MaxPointsInProgram; }
-      set
-      {
-        MaxPointsInProgramParameter.Value.Value = value;
-        config.MaxPointsInProgram = value;
-      }
-    }
-
-    /// <summary>
-    ///     This is the minimum size of an item on the CODE stack, expressed as a number of points.
-    ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
-    ///     exceeded
-    ///     should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
-    ///     instruction.
-    /// </summary>
-    public IValueParameter<IntValue> MinPointsInProgramParameter
-    {
-      get { return (IValueParameter<IntValue>)Parameters[MinPointsInProgramParameterName]; }
-    }
-
-    public int MinPointsInProgram
-    {
-      get { return config.MaxPointsInProgram; }
-      set
-      {
-        MinPointsInProgramParameter.Value.Value = value;
-        config.MinPointsInProgram = value;
-      }
-    }
-
-    /// <summary>
-    ///     The maximum number of points in an expression produced by the CODE.RAND instruction.
-    /// </summary>
-    public IValueParameter<IntValue> MaxPointsInRandomExpressionParameter
-    {
-      get { return (IValueParameter<IntValue>)Parameters[MaxPointsInRandomInstructionParameterName]; }
-    }
-
-    public int MaxPointsInRandomExpression
-    {
-      get { return config.MaxPointsInRandomExpression; }
-      set
-      {
-        MaxPointsInRandomExpressionParameter.Value.Value = value;
-        config.MaxPointsInRandomExpression = value;
-      }
-    }
-
-    /// <summary>
-    ///     When TRUE (which is the default), code passed to the top level of the interpreter
-    ///     will be pushed onto the CODE stack prior to execution.
-    /// </summary>
-    public IValueParameter<BoolValue> TopLevelPushCodeParameter
-    {
-      get { return (IValueParameter<BoolValue>)Parameters[TopLevelPushCodeParameterName]; }
-    }
-
-    public bool TopLevelPushCode
-    {
-      get { return config.TopLevelPushCode; }
-      set
-      {
-        TopLevelPushCodeParameter.Value.Value = value;
-        config.TopLevelPushCode = value;
-      }
-    }
-
-    /// <summary>
-    ///     When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.
-    /// </summary>
-    public IValueParameter<BoolValue> TopLevelPopCodeParameter
-    {
-      get { return (IValueParameter<BoolValue>)Parameters[TopLevelPopCodeParameterName]; }
-    }
-
-    public bool TopLevelPopCode
-    {
-      get { return config.TopLevelPopCode; }
-      set
-      {
-        TopLevelPopCodeParameter.Value.Value = value;
-        config.TopLevelPopCode = value;
-      }
-    }
-
-    public IValueParameter<IntValue> MaxStringLengthParameter
-    {
-      get { return (IValueParameter<IntValue>)Parameters[MaxStringLengthParameterName]; }
-    }
-
-    public int MaxStringLength
-    {
-      get { return config.MaxStringLength; }
-      set
-      {
-        MaxStringLengthParameter.Value.Value = value;
-        config.MaxStringLength = value;
+        InitProgramLengthParameter.Value.Value = value;
       }
     }
@@ -339,33 +148,39 @@
       var bestQuality = Maximization ? qualities.Max() : qualities.Min();
       var bestIdx = Array.IndexOf(qualities, bestQuality);
-      var bestIndividual = individuals[bestIdx].IntegerVector();
-
-      var isIndividualBetter = AnalyzeBestTrainingSolution(bestIndividual, bestQuality, results, random);
+      var vector = individuals[bestIdx].IntegerVector();
+      var seed = vector.GetSeed();
+      var rand = randomPool.Allocate();
+      rand.Reset(seed);
+
+      var program = vector.ToPushProgram(config, rand);
+      var isIndividualBetter = AnalyzeBestTrainingSolution(program, bestQuality, results, rand);
 
       if (isIndividualBetter) {
-        AnalyzeBestTestSolution(bestIndividual, results, random);
-      }
-    }
-
-    private void AnalyzeBestTestSolution(IntegerVector bestIndividual, ResultCollection results, IRandom random) {
-      var program = bestIndividual.ToPushProgram(config, randomPool);
-      var testResult = PushEvaluator.EvaluateTest(pool, program, random);
+        rand.Reset(seed);
+        AnalyzeBestTestSolution(program, results, rand);
+      }
+
+      randomPool.Free(rand);
+    }
+
+    private void AnalyzeBestTestSolution(PushProgram program, ResultCollection results, IRandom random) {
+      var testResult = PushEvaluator.EvaluateTraining(pool, program, random);
 
       if (!results.ContainsKey(TestQualityResultName)) {
-        results.Add(new Result(TestQualityResultName, new DoubleValue(testResult.TotalQuality)));
+        results.Add(new Result(TestQualityResultName, new DoubleValue(testResult.AvgQuality)));
       } else {
-        ((DoubleValue)results[TestQualityResultName].Value).Value = testResult.TotalQuality;
-      }
-    }
-
-    private bool AnalyzeBestTrainingSolution(IntegerVector bestIndividual, double bestQuality, ResultCollection results, IRandom random) {
-      var solution = CreatePushSolution(
-        bestIndividual,
-        bestQuality,
-        random,
-        config,
-        PushEvaluator);
-
+        ((DoubleValue)results[TestQualityResultName].Value).Value = testResult.AvgQuality;
+      }
+    }
+
+    private bool AnalyzeBestTrainingSolution(PushProgram program, double bestQuality, ResultCollection results, IRandom random) {
       if (!results.ContainsKey(BestTrainingSolutionResultName)) {
+        var solution = CreatePushSolution(
+            program,
+            bestQuality,
+            random,
+            config,
+            PushEvaluator);
+
         results.Add(new Result(BestTrainingSolutionResultName, solution));
         return true;
@@ -374,7 +189,12 @@
       var currentBestQuality = ((PushSolution)results[BestTrainingSolutionResultName].Value).Quality;
 
-      if (Maximization && currentBestQuality < bestQuality ||
-         !Maximization && currentBestQuality > bestQuality) {
-        results[BestTrainingSolutionResultName].Value = solution;
+      if ((!Maximization && currentBestQuality > bestQuality) ||
+           (Maximization && currentBestQuality < bestQuality)) {
+        results[BestTrainingSolutionResultName].Value = CreatePushSolution(
+            program,
+            bestQuality,
+            random,
+            config,
+            PushEvaluator);
         return true;
       }
@@ -383,6 +203,18 @@
     }
 
+    private EvaluationResult EvaluateIntegerVector(IntegerVector vector) {
+      var rand = randomPool.Allocate();
+      var seed = vector.GetSeed();
+      rand.Reset(seed);
+
+      var program = vector.ToPushProgram(config, rand);
+      var result = PushEvaluator.EvaluateTraining(pool, program, rand);
+      randomPool.Free(rand);
+
+      return result;
+    }
+
     protected abstract PushSolution CreatePushSolution(
-      IntegerVector vector,
+      PushProgram program,
       double bestQuality,
       IRandom random,
@@ -391,10 +223,10 @@
 
     public override double Evaluate(Individual individual, IRandom random) {
-      var program = individual.ToPushProgram(config, randomPool);
-      var result = PushEvaluator.EvaluateTraining(pool, program, random);
+      var vector = individual.IntegerVector();
+      var result = EvaluateIntegerVector(vector);
 
       individual[CaseQualitiesScopeParameterName] = new DoubleArray(result.ExampleQualities);
 
-      return result.TotalQuality;
+      return result.AvgQuality;
     }
   }
